#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "netex.h"
#include "config.h"

#define CONFIG_PATH "srv_config.json"
CONFIGURATION* srv_configuration;
int server_sockfd;
struct sockaddr_in server_sockaddr;

int initialize_server(int argc, char* argv[])
{
    // Config
    srv_configuration = config_load_from_path(CONFIG_PATH);
    if (srv_configuration == NULL)
    {
        WARN("Fallback to default config!");
        srv_configuration = config_create();
        config_set_int(srv_configuration, "Connection.Port", 6920);
        config_set_string(srv_configuration, "Connection.Host", "localhost");
        config_set_string(srv_configuration, "Connection.Crypto.CertPath", "cert.pem");
        if (config_save_to_path(srv_configuration, CONFIG_PATH) != 0)
        {
            WARN("Failed to save configuration to disk, default config is only available in memory!");
        }
    }
    netex_init();

    // Socket
    const int64_t portnum = config_get_int(srv_configuration, "Connection.Port");
    char* hostname = config_get_string(srv_configuration, "Connection.Host");
    server_sockfd = setup_socket(portnum, hostname);
    free(hostname);
    if (server_sockfd <= 0)
    {
        WARN("Could not create server sockedfd!");
        return 1;
    }
    return 0;
}

int server_execute(void)
{
    return 0;
}